<template>
	<div class="p-20" v-if="message">
		<div class="p-20 email-wrapper box-shadow h-100">
			<div class="flex justify-content-between align-items-baseline">
				<h2>{{ message.subject }}</h2>

				<div class="icon-button icon-button-red" @click="deleteMessage(message)">
					<i class="fas fa-trash-alt p-5"></i> 
				</div>
			</div>

			<div class="flex m-top-40 email-title">
				<div>
					<img src="@/assets/avatar.png" alt="user avatar">
				</div>

				<div class="m-left-20">
					<p>{{ message.from }}</p>

					<p class="p-top-10">{{ message.timestamp | timestamp }}</p>
				</div>
			</div>

			<div class="m-top-40">
				<div class="email-content" v-html="message.body" />
			</div>
		</div>
	</div>
</template>

<script>

export default {

	data() {
		
		return {

			message: null
		}
	},

	async created() {

		// Get selected message
		this.unwatch = this.$store.watch((state, getters) => getters.message, message => {

			this.message = message
		})	
	},

	methods: {

		deleteMessage(message) {

			// API example
			// axios.delete('/api/messages/' + this.message.id).then(response => { 

			// Remove message from array
			const index = this.$store.state.messages.findIndex(item => {

				return (message === item)
			})

			this.$store.state.messages.splice(index, 1)

			// Set first item for preview
			this.$store.commit('getMessage', this.$store.state.messages[0])

			// })
		}
	}
}
</script>

<style scoped>

.email-content img {
	width: auto;
    max-width: 100%;
}

.email-wrapper {
	max-height: calc(100vh - 160px); 
	overflow-y: auto;
}

</style>